/* Common template */

#include <cstring>
#include <cstdio>

#define zero(a) memset(a, 0, sizeof(a))

typedef long long ll;

/* Main part */

template <const int max_size, class Data, const Data default_value>
class hashTable
{
public:
  ll hash[max_size];
  Data f[max_size];
  int size;

  inline int position( ll H )
  {
    int i = H % max_size;
    while (hash[i] && hash[i] != H)
      if (++i == max_size)
        i = 0;
    return i;
  }

  hashTable() { zero(hash), size = 0; }

  Data get( ll H )
  {
    int i = position(H);
    return hash[i] ? f[i] : default_value;
  }

  Data & operator [] ( ll H )
  {
    int i = position(H);
    if (!hash[i])
      hash[i] = H, f[i] = default_value, size++;
    return f[i];
  }

  void set( ll H, Data val ) { (*this)[H] = val; }
};

int main()
{
  hashTable<(int)3e6 + 17, int, -1> h;

  const int M = (int)2e6;
  for (int i = 0; i < M; i++)
    h[i] = i;
  printf("%d\n", h[10]);
  return 0;
}
