#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <iterator>

using namespace std;


class Primes {
  static map <int, int> m;
public:
  static bool isPrime( int x ) {
    for (int i = 2; i * i <= x; i++)
      if (x % i == 0)
        return 0;
    return 1;
  }
  static int prime( int i ) {
    int x = 2;
    while (i > 0)
      if (isPrime(++x))
        i--;
    return x;
  }
  static int & get( int i ) {
    if (!m.count(i))
      m[i] = prime(i);
    return m[i];
  }
};
map <int, int> Primes::m;


class MyIterator : public iterator<random_access_iterator_tag, int> {
  int i;

public:
  explicit MyIterator( int i ) { this->i = i; }

  int & operator * ()               { return Primes::get(i); }
  MyIterator operator + ( int d )   { return MyIterator(i + d); }
  MyIterator operator - ( int d )   { return MyIterator(i - d); }
  int operator - ( MyIterator x )   { return i - x.i; }
  MyIterator operator ++ ()         { i++; return *this; }
  MyIterator operator -- ()         { i--; return *this; } 
  bool operator != ( MyIterator x ) { return i != x.i; };
  bool operator == ( MyIterator x ) { return i == x.i; };
  bool operator < ( MyIterator x )  { return i < x.i; };
};

void outPrimes( int M ) {
  for (int i = 0; i < M; i++)
    printf("%d ", Primes::get(i));
  puts("");
}

int main() {
  const int M = 10;
  outPrimes(M);
  random_shuffle(MyIterator(0), MyIterator(M));
  outPrimes(M);
  sort<MyIterator>(MyIterator(0), MyIterator(M));
  outPrimes(M);
  return 0;
}
