#include <cstdio>
#include <cstdlib>
#include <cstdarg>

#define DEBUG 0

const int maxn = 101;

char ch, s[maxn][maxn];
int W, H;

void Debug( char *format, ... )
{
  va_list ap;
  va_start(ap, format);
#if DEBUG
  vfprintf(stderr, format, ap);
  fflush(stderr);
#endif
}

void GetStartupInfo()
{
  Debug("get startup info\n");
  scanf("%d%d %c", &W, &H, &ch);
  Debug("ok (%d, %d, %c)\n", W, H, ch);
}

void GetBoard()
{
  Debug("get board\n");
  for (int i = 0; i < H; i++)
  {
    scanf("%s", s[i]);
    Debug("%02d : %s\n", i, s[i]);
  }
}

int rdtsc()
{
  asm("rdtsc");
}

int main()
{
  GetStartupInfo();
  srand(rdtsc());
  while (1)
  {
    GetBoard();
    Debug("move!\n");

    int x, y;
    do
    {
      x = rand() % W, y = rand() % H;
    } while (s[y][x] != '.');

    Debug("move = (%d, %d)\n", x, y);

    printf("%d %d\n", x, y);
    fflush(stdout);
  }
  return 0;
}
