#include <cstdio>
#include <cstdarg>

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define DEBUG 0

const int maxn = 101;

char ch, s[maxn][maxn];
int W, H;

void Debug( char *format, ... )
{
  va_list ap;
  va_start(ap, format);
#if DEBUG
  vfprintf(stderr, format, ap);
  fflush(stderr);
#endif
}

void GetStartupInfo()
{
  Debug("get startup info\n");
  scanf("%d%d %c", &W, &H, &ch);
  Debug("ok (%d, %d, %c)\n", W, H, ch);
}

void GetBoard()
{
  Debug("get board\n");
  for (int i = 0; i < H; i++)
  {
    scanf("%s", s[i]);
    Debug("%02d : %s\n", i, s[i]);
  }
}

int F()
{
  int sum = 0;
  int dx[] = {1, 1, 1, 0};
  int dy[] = {-1, 0, 1, 1};

  forn(i, H)
    forn(j, W)
      forn(d, 4)
      {
        int cnt1 = 0, cnt2 = 0, bad = 0;
        int x = j, y = i;
        forn(k, 5)
        {
          if (!(0 <= x && x < W && 0 <= y && y < H))
            bad = 1;
          else if (s[y][x] == ch)
            cnt1++;
          else if (s[y][x] != '.')
            cnt2++;

          x += dx[d], y += dy[d];
        }
        if (!bad && (!!cnt1 ^ !!cnt2))
        {
          int val = 1, x = cnt1 ? cnt1 : cnt2;
          while (x--)
            val *= 10;
          sum += cnt1 ? val : -val;
        }
      }
      
  return sum;
}

int main()
{
  GetStartupInfo();
  while (1)
  {
    GetBoard();
    Debug("move!\n");

    int max = -(int)1e9, rx = -1, ry = -1;
    forn(i, H)
      forn(j, W)
        if (s[i][j] == '.')
        {
          s[i][j] = ch;
          int tmp = F();
          if (tmp > max)
            max = tmp, rx = j, ry = i;
          s[i][j] = '.';
        }

    Debug("move = (%d, %d)\n", rx, ry);

    printf("%d %d\n", rx, ry);
    fflush(stdout);
  }
  return 0;
}
