#include <cstdio>
#include <cstdarg>

#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define DEBUG 0

const int inf = (int)1e9;
const int maxn = 101;

char ch, s[maxn][maxn];
int W, H;

void Debug( char *format, ... )
{
  va_list ap;
  va_start(ap, format);
#if DEBUG
  vfprintf(stderr, format, ap);
  fflush(stderr);
#endif
}

void GetStartupInfo()
{
  Debug("get startup info\n");
  scanf("%d%d %c", &W, &H, &ch);
  Debug("ok (%d, %d, %c)\n", W, H, ch);
}

void GetBoard()
{
  Debug("get board\n");
  for (int i = 0; i < H; i++)
  {
    scanf("%s", s[i]);
    Debug("%02d : %s\n", i, s[i]);
  }
}

int F( char ch )
{
  int sum = 0;
  int dx[] = {1, 1, 1, 0};
  int dy[] = {-1, 0, 1, 1};

  forn(i, H)
    forn(j, W)
      forn(d, 4)
      {
        int cnt1 = 0, cnt2 = 0, bad = 0;
        int x = j, y = i;
        forn(k, 5)
        {
          if (!(0 <= x && x < W && 0 <= y && y < H))
            bad = 1;
          else if (s[y][x] == ch)
            cnt1++;
          else if (s[y][x] != '.')
            cnt2++;

          x += dx[d], y += dy[d];
        }
        if (!bad && (!!cnt1 ^ !!cnt2))
        {
          int val = 1, x = cnt1 ? cnt1 : cnt2;
          while (x--)
            val *= 10;
          sum += cnt1 ? val : (-3 * val);
        }
      }
      
  return sum;
}

int tx, ty;

int GoodMove( char ch, int dep, int &rx, int &ry )
{
  int res = -inf;

  forn(i, H)
    forn(j, W)
      if (s[i][j] == '.')
      {
        s[i][j] = ch;
        int tmp = (dep == 1 ? F(ch) : -GoodMove('x' + 'o' - ch, dep - 1, tx, ty));
        if (tmp > res)
          res = tmp, rx = j, ry = i;
        s[i][j] = '.';
      }
  return res;
}

int main()
{
  GetStartupInfo();
  while (1)
  {
    GetBoard();
    Debug("move!\n");

    int rx, ry, res = GoodMove(ch, 2, rx, ry);
    Debug("move = (%d, %d), res = %d\n", rx, ry, res);

    printf("%d %d\n", rx, ry);
    fflush(stdout);
  }
  return 0;
}
