import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class Report {

	final String LISTFILE = "list.list";

	public void run() throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(LISTFILE));
		ArrayList<String> programs = new ArrayList<String>();
		while (true) {
			String s = br.readLine();
			if (s == null)
				break;
			programs.add(s);
		}
		System.err.println(programs.size());
		int[][] res = new int[programs.size()][programs.size()];
		int n = programs.size();
		int cnt = 1;
		int[] points = new int[res.length];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j)
					continue;
				System.err.println(i + " " + j + " " + cnt);
				BufferedReader log = new BufferedReader(new FileReader("game"
						+ (cnt) + ".log"));
				cnt++;
				String prev = "";
				while (true) {
					String s = log.readLine();
					if (s == null)
						break;
					prev = s;
				}
				System.err.println("prev = " + prev);
				if (prev.equalsIgnoreCase("win")) {
					res[i][j] = 1;
					points[i] += 3;
				} else if (prev.equalsIgnoreCase("lose")) {
					res[i][j] = -1;
					points[j] += 3;
				} else if (prev.equalsIgnoreCase("draw")) {
					res[i][j] = 0;
					points[i] += 1;
					points[j] += 1;
				} else {
					throw new AssertionError(prev);
				}
			}
		}
		PrintWriter out = new PrintWriter("results.html");
		out.println("<html><body><table border=\"1\">");
		out.print("<tr><th>&nbsp;</th>");
		for (String s : programs) {
			out.print("<th>" + s + "</th>");
		}
		out.println("<th>Res</th></tr>");
		cnt = 1;
		for (int i = 0; i < programs.size(); i++) {
			String s = programs.get(i);
			out.print("<tr><td>" + s + "</td>");
			for (int j = 0; j < programs.size(); j++) {
				if (i == j) {
					out.print("<td>&nbsp;</td>");
				} else {
					out.print("<td><a href=\"game" + (cnt++) + ".log\">"
							+ OUTCOME[res[i][j] + 1] + "/"
							+ OUTCOME[res[j][i] + 1] + "</a></td>");
				}
			}
			out.println("<td>" + points[i] + "</td></tr>");
		}
		out.println("</table></body></html>");
		out.close();
	}

	final String[] OUTCOME =
	{ "0", "1", "3" };

	public static void main(String[] args) throws IOException {
		new Report().run();
	}
}
