import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class Report_sk {

	final String LISTFILE = "list.list";

	final int WIN = 0;
	final int DRAW = 1;
	final int LOSE = 2;

	final String[] OUTCOME = { "3", "1", "0" };

	public void run() throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(LISTFILE));
		ArrayList<String> programs = new ArrayList<String>();
		while (true) {
			String s = br.readLine();
			if (s == null)
				break;
			programs.add(s);
		}
		System.err.println(programs.size());
		int[][] res = new int[programs.size()][programs.size()];
		int n = programs.size();
		int cnt = 1;
		int[] points = new int[res.length];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j)
					continue;
				System.err.println(i + " " + j + " " + cnt);
				BufferedReader log = new BufferedReader(new FileReader("game"
						+ (cnt) + ".log"));
				cnt++;
				String prev = "";
				while (true) {
					String s = log.readLine();
					if (s == null)
						break;
					prev = s;
				}
				System.err.println("prev = " + prev);
				if (prev.equalsIgnoreCase("win")) {
					res[i][j] = WIN;
					points[i] += 3;
				} else if (prev.equalsIgnoreCase("lose")) {
					res[i][j] = LOSE;
					points[j] += 3;
				} else if (prev.equalsIgnoreCase("draw")) {
					res[i][j] = DRAW;
					points[i] += 1;
					points[j] += 1;
				} else {
					throw new AssertionError(prev);
				}
			}
		}
		PrintWriter out = new PrintWriter("results.html");
		out.println("<html><body>\n");
		out.println("<table border=\"1\">\n");
		for (int i = 0; i < programs.size(); i++)
			out.println("<tr><td>"  + (i + 1) + "</td><td>" + programs.get(i) + "</td></tr>\n");
		out.println("</table>\n");

		cnt = 1;

		int p[] = new int[n];
		for (int i = 0; i < n; i++)
		  p[i] = i;
		for (int i = 0; i < n; i++)
			 for (int j = 1; j < n; j++)
			 	if (points[p[j - 1]] < points[p[j]])
			 	{
			 		int tmp = p[j - 1];
			 		p[j - 1] = p[j];
			 		p[j] = tmp;
			 	}

		int p2[] = new int[n];
		for (int i = 0; i < n; i++)
			p2[p[i]] = i;		 		

	    int[][] no = new int[n][n];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				if (i != j)
					no[i][j] = cnt++;
		 
		out.println("<table border=\"1\">\n");
		out.print("<tr><th>&nbsp;</th>");
		for (int i = 0; i < n; i++) {
			out.print("<th>" + (p[i] + 1) + "</th>");
		}
		out.println("<th>Res</th></tr>");
	
		for (int id = 0; id < programs.size(); id++) {
			int i = p[id];
			out.print("<tr><td>" + (i + 1) + "</td>");
			for (int j = 0; j < programs.size(); j++) {
				if (id == j) {
					out.print("<td>&nbsp;</td>");
				} else {
					out.print("<td><a href=\"game" + no[i][p[j]] + ".log\">"
							+ OUTCOME[res[i][p[j]]] + "/"
							+ OUTCOME[2 - res[p[j]][i]] + "</a></td>");
				}
			}
			out.println("<td>" + points[i] + "</td></tr>");
		}
		out.println("</table></body></html>");
		out.close();
	}


	public static void main(String[] args) throws IOException {
		new Report_sk().run();
	}
}
