#define _CRT_SECURE_NO_DEPRECATE
#undef UNICODE

#include <windows.h>

#include <cstdio>
#include <cmath>

#include <string>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

HANDLE hOut;

void ErrorExit( string s )
{
    TCHAR szBuf[80]; 
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL, dw, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,
        0, NULL);

    wsprintf(szBuf, "%s | code = %d | error = %s", s.c_str(), dw, lpMsgBuf);
 
    MessageBox(NULL, szBuf, "Error", MB_OK); 

    LocalFree(lpMsgBuf);
    ExitProcess(dw);
}

void Write( int x, int y, int color )
{
	COORD c;
	c.X = x, c.Y = y;
	SetConsoleTextAttribute(hOut, color);
	SetConsoleCursorPosition(hOut, c);
}

const int maxn = 100;

char ch[] = {'x', 'o'};
char s[maxn][maxn];

int Color( char ch )
{
	if (ch == 'x') return 2;
	if (ch == 'o') return 5;
	return 7;
}

int main( int argc, char *argv[] )
{
	if (argc < 2)
	{
		puts("Usage: <log> [sleep]");
		puts("log - file with history to visualize");
		puts("sleep - delay between moves (in miliseconds, default = 100)");
		return 0;
	}
	int sleep = 100;
	if (argc >= 3)
		sleep = atoi(argv[2]);

	hOut = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTitle("Cross-Zero game");

	CONSOLE_CURSOR_INFO cInf;
	GetConsoleCursorInfo(hOut, &cInf);
	cInf.bVisible = false;
	if (!SetConsoleCursorInfo(hOut, &cInf))
		ErrorExit("SetConsoleCursorInfo");

	FILE *F;
	if ((F = fopen(argv[1], "rt")) == NULL)
		ErrorExit("freopen");

	int W, H, cc = 0;
	char name[2][100];
	fscanf(F, "%d%d ", &W, &H);
	forn(i, 2)
	{
		char *s = name[i];
		fgets(s, sizeof(name[i]), F);
		s[strlen(s) - 1] = 0;
	}
	printf("W=%d H=%d\n", W, H);
	forn(i, H)
		forn(j, W)
			s[i][j] = '.';

	int x, y;
	while (fscanf(F, "%d%d", &x, &y) == 2 && !(x == -1 && y == -1))
	{
		s[y][x] = ch[cc], cc ^= 1;
		forn(i, H)
			forn(j, W)
			{
				int color = Color(s[i][j]);
				if (j == x && i == y)
					color += 8;
				Write(j, i, color), printf("%c", s[i][j]);
			}
		Write(0, H + 1, Color('x') + 8), printf("Player One = x [%s]", name[0]);
		Write(0, H + 2, Color('o') + 8), printf("Player Two = o [%s]", name[1]);
		Write(0, H + 3, 7);
		Sleep(sleep);
	}
	cc ^= 1;

	enum {OK, PE, TL, DRAW};
	int res;
	fscanf(F, "%d", &res);
	Write(0, H + 4, 15);
	if (res == PE)
		printf("PE : player %d : move is incorrect", cc + 1);
	else if (res == TL)
		printf("TL : player %d : time limit exceeded", cc + 1);
	else if (res == OK)
		printf("OK : player %d wins!\n", cc + 1);
	else if (res == DRAW)
		printf("Draw :-D\n");
	

	char buf[99];
	Write(0, H + 5, 7), puts("Press Enter...");
	gets(buf);
	return 0;
}
