#define _CRT_SECURE_NO_WARNINGS

#undef UNICODE
#include <windows.h>
#undef UNICODE

#include <cstdio>
#include <cstring>
#include <cassert>

#include <string>

using namespace std;

void ErrorExit( string s )
{
    TCHAR szBuf[80]; 
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL);

    wsprintf(szBuf, "%s | code = %d | error = %s", s.c_str(), dw, lpMsgBuf);
 
    MessageBox(NULL, szBuf, "Error", MB_OK); 

    LocalFree(lpMsgBuf);
    ExitProcess(dw);
}

int main( int argc, char *argv[] )
{
	if (argc < 3)
	{
		puts("Usage: <a> <b>");
		return 0;
	}

	char *name[2] = {argv[1], argv[2]};
	STARTUPINFO sa[2];
	PROCESS_INFORMATION pi[2];
	memset(sa, 0, sizeof(sa));

	SECURITY_ATTRIBUTES hsa[2];
	HANDLE hIn[2], hOut[2];

	for (int i = 0; i < 2; i++)
	{
		printf("Create (%s)\n", name[i]);
		
		hsa[i].nLength = sizeof(SECURITY_ATTRIBUTES); 
		hsa[i].bInheritHandle = TRUE; 
		hsa[i].lpSecurityDescriptor = NULL; 
		if (!CreatePipe(&hIn[i], &hOut[i], &hsa[i], 0))
			ErrorExit("CreatePipe");

		sa[i].cb = sizeof(STARTUPINFO);
		sa[i].hStdInput = hIn[i];
		sa[i].hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
		sa[i].hStdError = GetStdHandle(STD_OUTPUT_HANDLE);
		sa[i].dwFlags |= STARTF_USESTDHANDLES;

		if (!CreateProcess(name[i], NULL, NULL, NULL, TRUE, 0, NULL, NULL, &sa[i], &pi[i]))
			ErrorExit("Create process '" + string(name[i]) + "'");
	}

	for (int i = 10; i >= 0; i--)
	{
		char s[99];
		sprintf(s, "%d ", i);
		printf("i=%d s=%s\n", i, s);
		
		DWORD len;
		BOOL res = WriteFile(hOut[0], s, (DWORD)strlen(s), &len, 0);
		if (!res)
		{
			printf("can not execute WriteFile\n");
			return 1;
		}
		//fprintf((FILE *)hOut[0], "%s", s);
		assert(len == strlen(s));
	}

	for (int i = 0; i < 2; i++)
	{
		printf("Wait for process number %d... ", i);
		fflush(stdout);
		if (WaitForSingleObject(pi[i].hProcess, 3000) == WAIT_TIMEOUT)
		{
			puts("Kill =(");
			TerminateProcess(pi[i].hProcess, 0);
		}
		else
			puts("Ok");
		fflush(stdout);
	}
	return 0;
}