#define _CRT_SECURE_NO_WARNINGS
#undef UNICODE

#include <windows.h>

#include <cstdio>
#include <cstring>
#include <cassert>

#include <string>

using namespace std;

void ErrorExit( string s )
{
    TCHAR szBuf[80]; 
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL, dw, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,
        0, NULL);

    wsprintf(szBuf, "%s | code = %d | error = %s", s.c_str(), dw, lpMsgBuf);
 
    MessageBox(NULL, szBuf, "Error", MB_OK); 

    LocalFree(lpMsgBuf);
    ExitProcess(dw);
}

char ReadChar( HANDLE h )
{
	char c;
	DWORD len;
//	fprintf(stderr, " [ReadChar: begin] ");
	if (!ReadFile(h, &c, 1, &len, 0))
		ErrorExit("Read error");
//	fprintf(stderr, " [ReadChar: ok, c=%d] ", c);
	assert(len == 1);
	return c;
}

int ReadInt( HANDLE h )
{
	char c = ReadChar(h);
	while (!isdigit(c))
		c = ReadChar(h);

	int x = 0;
	while (isdigit(c))
		x = x * 10 + c - '0', c = ReadChar(h);
	return x;
}

int main( int argc, char *argv[] )
{
	if (argc < 3)
	{
		puts("Usage: <a> <b>");
		return 0;
	}
	char *name[] = {argv[1], argv[2]};

	STARTUPINFO sa[2];
	PROCESS_INFORMATION pi[2];

	HANDLE hStdinRd[2], hStdinWr[2];
	HANDLE hStdoutRd[2], hStdoutWr[2];
	SECURITY_ATTRIBUTES hsaStdin[2], hsaStdout[2];

	SECURITY_ATTRIBUTES sec_tmp;
	sec_tmp.nLength = sizeof(SECURITY_ATTRIBUTES);
	sec_tmp.bInheritHandle = TRUE; 
	sec_tmp.lpSecurityDescriptor = NULL; 
	HANDLE tmp = CreateFile("nul", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, &sec_tmp, 
		CREATE_ALWAYS, 0, 0);
	if (tmp == INVALID_HANDLE_VALUE)
		ErrorExit("nul Handle");
//	if (!SetStdHandle(STD_ERROR_HANDLE, tmp))
//		ErrorExit("SetStdHandle");

	for (int i = 0; i < 2; i++)
	{
		printf("Create process %d : %s\n", i, name[i]);

		hsaStdin[i].nLength = sizeof(SECURITY_ATTRIBUTES);
		hsaStdin[i].bInheritHandle = TRUE; 
		hsaStdin[i].lpSecurityDescriptor = NULL; 
		if (!CreatePipe(&hStdinRd[i], &hStdinWr[i], &hsaStdin[i], 0))
			ErrorExit("CreatePipe for stdin");

		hsaStdout[i].nLength = sizeof(SECURITY_ATTRIBUTES);
		hsaStdout[i].bInheritHandle = TRUE; 
		hsaStdout[i].lpSecurityDescriptor = NULL; 
		if (!CreatePipe(&hStdoutRd[i], &hStdoutWr[i], &hsaStdout[i], 0))
			ErrorExit("CreatePipe for stdout");

		memset(&sa[i], 0, sizeof(sa[i]));
		sa[i].cb = sizeof(STARTUPINFO);
		sa[i].hStdInput = hStdinRd[i];
		sa[i].hStdOutput = hStdoutWr[i];
		sa[i].hStdError = GetStdHandle(STD_ERROR_HANDLE);
		sa[i].dwFlags |= STARTF_USESTDHANDLES;

		if (!CreateProcess(name[i], 0, 0, 0, TRUE, 0, 0, 0, &sa[i], &pi[i]))
			ErrorExit("CreateProcess");
	}

	int n = 1, cc = 0;
	char buf[999];
	while (n < (int)1e9)
	{
		printf("n=%d cc=%d\n", n, cc);

		sprintf(buf, "%d ", n);
		DWORD len, bufl = (DWORD)strlen(buf);
		WriteFile(hStdinWr[cc], buf, bufl, &len, 0);
		assert(len == bufl);

		n = ReadInt(hStdoutRd[cc]);

		cc ^= 1;
	}

	for (int i = 0; i < 2; i++)
	{
		TerminateProcess(pi[i].hProcess, 0);
		WaitForSingleObject(pi[i].hProcess, 3000);
	}
	return 0;
}
