#undef UNICODE

#include <windows.h>

#include <cstdio>
#include <cmath>

#include <string>

using namespace std;

HANDLE hOut;

void ErrorExit( string s )
{
    TCHAR szBuf[80]; 
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL, dw, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf,
        0, NULL);

    wsprintf(szBuf, "%s | code = %d | error = %s", s.c_str(), dw, lpMsgBuf);
 
    MessageBox(NULL, szBuf, "Error", MB_OK); 

    LocalFree(lpMsgBuf);
    ExitProcess(dw);
}
void Write( int x, int y, int color, const char *s )
{
	COORD c;
	c.X = x, c.Y = y;
	
	SetConsoleTextAttribute(hOut, color);
	SetConsoleCursorPosition(hOut, c);
	printf("%s", s);
	SetConsoleTextAttribute(hOut, 7); // gray
}

int main()
{
	hOut = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTitle("Cross-Zero game");

	CONSOLE_CURSOR_INFO cInf;
	GetConsoleCursorInfo(hOut, &cInf);
	cInf.bVisible = false;
	if (!SetConsoleCursorInfo(hOut, &cInf))
		ErrorExit("SetConsoleCursorInfo");

	int r = 20;
	COORD c;
	c.X = 80, c.Y = 50;
	if (!SetConsoleScreenBufferSize(hOut, c))
		ErrorExit("SetConsoleScreenBufferSize");

	while (true)
	{
		double t = GetTickCount() * 1e-3;
		for (int i = 0; i < 3; i++)
			Write(i, i, i + 1, "A");
		Write((int)(r * (1 + cos(t))), (int)(r * (1 + sin(t))), 12, "Hello!");
		Sleep(10);
		Write((int)(r * (1 + cos(t))), (int)(r * (1 + sin(t))), 0, "Hello!");
	}
	return 0;
}
