#ifndef __TGL_H__
#define __TGL_H__

#pragma comment (lib, "gdi32.lib")
#pragma comment (lib, "user32.lib")

#include <windows.h>
#include <windowsx.h>

typedef double DOUBLE;
typedef char CHAR;
typedef unsigned char BYTE;
typedef int INT;
typedef int BOOL;

#define VOID void

#define COM_SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define COM_RGB(R, G, B) (((DWORD)(R) << 16) + ((DWORD)(G) << 8) + (DWORD)(B))
#define COM_ABS(A) ((A) > 0 ? (A) : -(A))
#define COM_MAX(A, B) ((A) > (B) ? (A) : (B))
#define COM_MIN(A, B) ((A) < (B) ? (A) : (B))

#define GR2RAD(A) ((DOUBLE)(A) / PI * 180)
#define RAD2GR(A) ((DOUBLE)(A) / 180 * PI)

extern HWND TGL_hWnd;

BOOL TGL_Init( CHAR *T, INT Width, INT Height, BYTE BackColor );
VOID TGL_SetWindowHandle( VOID *Func );
VOID TGL_WinOnDestroy( HWND hWnd );
VOID TGL_Update( VOID );
VOID TGL_PutPixel( INT X, INT Y, COLORREF Color );
VOID TGL_Clear( VOID );
VOID TGL_PutWindowText( CHAR *Str );
VOID TGL_GetMouseCoor( POINT *P );

#endif
