#include <process.h>
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

CRITICAL_SECTION section; 
HANDLE h, in;
int dx[] = {1, -1, 0, 0};
int dy[] = {0, 0, 1, -1};
FILE *F;

int nextY()
{
  static int y = 0;
  y = (y + 1) % 20;
  return y + 1;
}

void Select( int x, int y, int color )
{
  COORD c;
  c.X = x, c.Y = y;
  SetConsoleCursorPosition(h, c);
  SetConsoleTextAttribute(h, color);
}

void Write( int x, int y, int color, char ch )
{  
  EnterCriticalSection(&section);
  Select(x, y, color);
  putchar(ch);
  fflush(stdout);
  LeaveCriticalSection(&section);
}

void Write( int x, int y, int color, const char *fmt, ... )
{  
  EnterCriticalSection(&section);
  Select(x, y, color);

  va_list ap;
  va_start(ap, fmt);
  vprintf(fmt, ap);
  fflush(stdout);

  LeaveCriticalSection(&section);
}

void Bacteria( void *p )
{
  char ch = *((char *)p + 0);
  char color = *((char *)p + 1);

  Write(0, nextY(), 15, "clock = %ld\n", clock());
  
  srand(clock());
  int W = 60, H = 25;
  int x = rand() % W + 1;
  int y = rand() % H + 1;

  while (1)
  {
    Write(x, y, color, ch);
    Sleep(50);

    int k = rand() % 4;
    x += dx[k], y += dy[k];
    if (!(1 <= x && x <= W && 1 <= y && y <= H))
      x -= dx[k], y -= dy[k];
  }
}

void KeyHandler( void * )
{
  int run = 1;
  while (run)
  {
    INPUT_RECORD InRec;
    DWORD NumRead;
    ReadConsoleInput(in, &InRec, 1, &NumRead);

    switch (InRec.EventType)
    {
    case KEY_EVENT:
      char ch = InRec.Event.KeyEvent.uChar.AsciiChar;
      if (ch == 27)
        run = 0;
      else
        Write(0, nextY(), 12, "Key %d is pressed", ch);
      break;
    }
  }
  exit(0);
}

int main()
{
  InitializeCriticalSection(&section);

  h = GetStdHandle(STD_OUTPUT_HANDLE);
  in = GetStdHandle(STD_INPUT_HANDLE);

  system("cls");
  Write(0, 0, 10, "Press ESC to save your mind [ EXIT ]");
  _beginthread(KeyHandler, 0, 0);
  while (1)
  {
    char *buf = new char[2];
    buf[0] = rand() % 26 + 'A';
    buf[1] = 1 + rand() % 15;
    _beginthread(Bacteria, 0, (void *)buf);
    Sleep(500);
  }
  DeleteCriticalSection(&section);
  return 0;
}
