#pragma comment (lib, "gdi32.lib")
#pragma comment (lib, "user32.lib")

#include <windows.h>
#include <windowsx.h>

#define MY_CLASS_NAME "My Window"

static LRESULT CALLBACK GraphWinFunc( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam )
{
  if (Msg == WM_DESTROY)
    PostQuitMessage(0);
  return DefWindowProc(hWnd, Msg, wParam, lParam);
} 

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow )
{
  HWND hWnd;
  MSG msg;
  WNDCLASSEX wc;
  INT Params[2] = {200, 200}; // Width, Height
  char *Title = "Example Window";

  wc.cbSize = sizeof(WNDCLASSEX);
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = sizeof(VOID *);
  wc.hbrBackground = GetStockObject(BLACK_BRUSH);
  wc.hCursor = NULL;
  wc.hIcon = NULL;
  wc.hIconSm = NULL;
  wc.hInstance = NULL;
  wc.lpszClassName = MY_CLASS_NAME;
  wc.lpszMenuName = NULL;
  wc.lpfnWndProc = GraphWinFunc;
  if (!RegisterClassEx(&wc))
    return 1;

  hWnd = CreateWindow(MY_CLASS_NAME, Title,
    WS_SYSMENU | WS_OVERLAPPED | WS_BORDER | WS_CAPTION,
    10, 30, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, GetModuleHandle(NULL), Params);
  ShowWindow(hWnd, SW_SHOWNORMAL);
  UpdateWindow(hWnd);
  while (TRUE)
    if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
      if (msg.message == WM_QUIT)
        break;
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  return 0;
}